<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8"/>
<title>Soumettre un évènement</title>
<link rel="stylesheet" type="text/css" href="stylesheet.css"/>

<script type="text/javascript">
// GLOBALS
var url = window.location.href;
var host = window.location.origin;
let pathname = window.location.pathname;
var path = pathname.substring(0, pathname.lastIndexOf('/')+1);
var script = 'server.php';
var server = host + path + script;


// FETCH
// envoie data à l'url et retourne la réponse 
async function post_data(url, data) {
	//console.log('fetching from "'+url+'"...');
	const response = await fetch(url, {
		method: 'POST',
		mode: 'cors',
		cache: 'no-cache',
		credentials: 'omit',
		redirect: 'follow',
		referrer: 'no-referrer',
		body: JSON.stringify(data)
	});
	//console.log('fetched! parsing...');
	/*let text = await response.text();
	console.log(text);*/
	let res = await response.json(); // JSON to js object
	//console.log('parsing is done!');
	return res;
}


// COOKIES
function setCookie(name, value, days = 1) {
	let expires = "";
	if(days) {
		var date = new Date();
		date.setTime(date.getTime() + (days*24*60*60*1000));
		expires = "; expires=" + date.toUTCString();
	}
	document.cookie = name + "=" + (value || "")  + expires + "; path=/";
}

function getCookie(name) {
	let nameEQ = name + "=";
	let ca = document.cookie.split(';');
	for(let i=0; i<ca.length; i++) {
		let c = ca[i];
		while(c.charAt(0) == ' '){
			c = c.substring(1, c.length);
		}
		if(c.indexOf(nameEQ) == 0) {
			return c.substring(nameEQ.length, c.length);
		}
	}
	return null;
}

function eraseCookie(name) {   
	document.cookie = name + '=; Max-Age=-99999999;';
}


// PERMISSIONS
// pas connecté
if(getCookie('user_id') === null) {
	alert('Il faut être connecté pour soumettre un évènement !');
	window.location.replace('evenements.html');
}

// role sans permission de contribution
if(getCookie('role') === 'utilisateur') {
	alert('Vous n\'avez pas les permissions pour soumettre un évènement !');
	window.location.replace('evenements.html');
}

// REQUETE
// soumettre un évènement
function contribution_event() {
	let parameters = {};
	let champs = ['titre', 'description', 'contact', 'public', 'debut', 'fin', 'theme', 'effectif_min', 'effectif_max', 'adresse', 'code_postal'];

	for(let c of champs) {
		if(c == 'debut' || c == 'fin') {
			let date = document.getElementById(c+'_date').value;
			let heure = document.getElementById(c+'_heure').value;
			let timestamp = date+' '+heure;
			parameters[c] = timestamp;
		} else {
			let value = document.getElementById(c).value || null;
			parameters[c] = value;
		}
	}

	let query = {
		'type': 'call',
		'procedure': 'insert_event',
		'parameters': parameters
	};

	post_data(server, query)
	.then(res => {
		if(res['error']) {
			alert(res['error']);
			return;
		}

		alert('Évènement soumis !');
		//TODO
	});
}
</script>
</head>

<body>
<div id="padding"></div>
<h3>Soumettre un évènement</h3>
<form action="javascript:contribution_event()">
	<p> Titre <span class="required">*</span> : </p>
	<input type="text" id="titre" required>

	<p> Description <span class="required">*</span> : </p>
	<textarea id="description" required></textarea>

	<p> Public <span class="required">*</span> : </p>
	<select id="public" required>
		<option value="tous publics">Tous publics</option>
		<option value="enfants">Enfants</option>
		<option value="adultes">Adultes</option>
	</select>

	<p> Debut <span class="required">*</span> : </p>
	<input type="date" id="debut_date" required>
	<input type="time" id="debut_heure">

	<p> Fin <span class="required">*</span> : </p>
	<input type="date" id="fin_date" required>
	<input type="time" id="fin_heure">

	<p> Thème <span class="required">*</span> : </p>
	<select id="theme" required></select>

	<p> Effectif minimum : </p>
	<input type="number" id="effectif_min" min="0">

	<p> Effect maximum : </p>
	<input type="number" id="effectif_max" min="0">

	<p> Contact <span class="required">*</span> : </p>
	<input type="text" id="contact">

	<hr>
	<p> Adresse <span class="required">*</span> : </p>
	<input type="text" id="adresse" required>

	<p> Code postal <span class="required">*</span> : </p>
	<input type="text" id="code_postal" required>

	<br>
	<input type="submit" value="Soumettre">
</form>

<script type="text/javascript">
// ÉLÉMENTS DYNAMIQUES
// navbar
let navbar = document.createElement('div');
navbar.id = 'navbar';
navbar.className = 'navbar_elems';

let accueil = document.createElement('a');
let evenement = document.createElement('a');
let contribution = document.createElement('a');

accueil.className = evenement.className = contribution.className = navbar.className;

accueil.id = 'nb0';
evenement.id = 'nb1';
contribution.id = 'nb2';

accueil.href = './index.html';
evenement.href = './evenements.html';
contribution.href = './contribution.html';

accueil.innerHTML = 'Accueil';
evenement.innerHTML = 'Évènement';
contribution.innerHTML = 'Soumettre un évènement';

navbar.appendChild(accueil);
navbar.appendChild(evenement);
navbar.appendChild(contribution);

if(getCookie('user_id') != null) {
	let profil = document.createElement('a');
	profil.className = navbar.className;
	profil.id = 'nb3';
	profil.href = './profil.html';
	profil.innerHTML = 'Connecté en tant que ' + getCookie('pseudo');
	navbar.appendChild(profil);
	
	let disconnect = document.createElement('a');
	disconnect.className = navbar.className;
	disconnect.id = 'nb4';
	disconnect.innerHTML = 'Déconnexion';
	disconnect.onclick = function() {
		eraseCookie('user_id');
		eraseCookie('pseudo');
		eraseCookie('role');
		eraseCookie('contact');
		window.location.reload(true);
	}
	navbar.appendChild(disconnect);
}
else {
	let connect = document.createElement('a');
	connect.className = navbar.className;
	connect.id = 'nb3';
	connect.href = './connexion.html';
	connect.innerHTML = 'Connexion';
	navbar.appendChild(connect);

	let sign_in = document.createElement('a');
	sign_in.className = navbar.className;
	sign_in.id = 'nb4';
	sign_in.href = './inscription.html';
	sign_in.innerHTML = 'S\'inscrire';
	navbar.appendChild(sign_in);
}

document.body.insertBefore(navbar, document.body.firstChild);

// population de la table thème
let query = {
	'type': 'call',
	'procedure': 'available_themes',
	'parameters': {}
};

post_data(server, query)
.then(res => {
	if(res['error']) {
		alert(res['error']);
		return;
	}

	let result = res['result'];
	let select = document.getElementById('theme');

	for(let r in result) {
		let option = document.createElement('option');
		option.innerHTML = result[r]['nom'];

		if(r == result[0]) {
			option.selected = true;
		}

		select.appendChild(option);
	}
});

// debut est 'maintenant' par défaut et au minimum
post_data(server, 'now')
.then(now => {
	let debut_date = document.getElementById('debut_date');
	debut_date.value = now['date'];
	debut_date.min = debut_date.value;

	let debut_heure = document.getElementById('debut_heure');
	debut_heure.value = now['hour'];

	// fin est aujourd'hui au minimum
	let fin_date = document.getElementById('fin_date');
	fin_date.min = debut_date.value;

	// debut < fin
	debut_date.addEventListener('change', function() {
		fin_date.min = this.value;
	});

	fin_date.addEventListener('change', function() {
		debut_date.max = this.value;
	});
});

// effectif min < max
let effectif_min = document.getElementById('effectif_min');
let effectif_max = document.getElementById('effectif_max');

effectif_min.addEventListener('change', function() {
	effectif_max.min = this.value;
});
effectif_max.addEventListener('change', function() {
	effectif_min.max = this.value;
});

// contact est celui du contributeur par défaut
let contact = document.getElementById('contact');
contact.value = getCookie('contact');
</script>
</body>
</html>